//////////////////////////////////////////////////////////////////////////////
// LINKC.C                                                                  //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "sound.h"
#include "gameplay.h"

typedef struct
{
	unsigned long ballx, bally;
} BallPos; // 1

typedef struct
{
	unsigned int balltile; // 1
} BallTile; // 2

typedef struct
{
	unsigned int x, y, tile; // 3
} MapChange; // 3

unsigned int rxtype, txtype, rxlen, txlen;
char rxdata[4], txdata[4];
char *prxdata, *ptxdata;

//////////////////////////////////////////////////////////////////////////////
// LinkIrq                                                                  //
//////////////////////////////////////////////////////////////////////////////
void LinkIrq()
{
	// receive
	if (rxlen == 0)
	{
		prxdata = rxdata;
		switch (rxtype = SB_REG)
		{
			case 1:
				rxlen = 4;
				break;
			case 2:
				rxlen = 1;
				break;
			case 3:
				rxlen = 3;
				break;
			case 0xFF: // disconnected or something
				enable_interrupts();
				while (SB_REG == 0xFF);
				break;
		}
	}
	else
	{
		*prxdata++ = SB_REG;
		if (--rxlen == 0)
		{
			switch (rxtype)
			{
				case 1:
					ball2x = ((BallPos*)rxdata)->ballx;
					ball2y = ((BallPos*)rxdata)->bally;
					break;
					
				case 2:
					//ball2tile = ((BallTile*)linkdata)->balltile;
					break;
					
				case 3:
					//PUT_TILE
					break;
			}
		}
	}
	
	// transmit
	if (txlen == 0)
	{
		ptxdata = txdata;
		txtype = 1;
		switch (txtype)
		{
			case 1:
				((BallPos*)txdata)->ballx = ballx;
				((BallPos*)txdata)->bally = bally;
				txlen = 4;
				break;
				
			case 2:
				//ball2tile = ((BallTile*)linkdata)->balltile;
				txlen = 0;
				break;
				
			case 3:
				//PUT_TILE
				txlen = 0;
				break;
		}
		SB_REG = txtype;		
	}
	else
	{
		SB_REG = *ptxdata++;
		txlen--;
	}
	
	if ((SC_REG & 1) == 0)
		SC_REG |= 0x80;
}

//////////////////////////////////////////////////////////////////////////////
// InitLink                                                                 //
//////////////////////////////////////////////////////////////////////////////
void InitLink()
{
	rxlen = txlen = 0;
	IE_REG &=~ SIO_IFLAG;

	SB_REG = '?';
	SC_REG = 0x81;					// send '?' with clock (query other GB)
	while (SC_REG & 0x80);
	if (SB_REG != '!')				// no response? them we wait
	{
		do
		{
			SB_REG = '!';
			SC_REG = 0x80;			// send '!' without clock (response)
			while (SC_REG & 0x80);
		} while (SB_REG != '?');	// repeat until query detected
	}

	IE_REG |= SIO_IFLAG;
	SC_REG |= 0x80;					// start transfer in current mode
}
