//////////////////////////////////////////////////////////////////////////////
// SOUND.H                                                                  //
//////////////////////////////////////////////////////////////////////////////
#ifndef _SOUND_H
#define _SOUND_H

//////////////////////////////////////////////////////////////////////////////
// sound defines                                                            //
//////////////////////////////////////////////////////////////////////////////
//		identifier	priority,	variable,	bank
#define SFX_BOUNCE		0,		bounce,		5
#define SFX_CRACK		1,		crack,		5
#define SFX_PICKUP		10,		pickup,		5
//#define SFX_SELECT		3,		select,		5
#define SFX_BREAKGL		50,		breakgl,	2
#define SFX_ENDLEVEL	100, 	endlevel,	5
#define SFX_GAMEOVER	100,	gameover,	6

//////////////////////////////////////////////////////////////////////////////
// sound variables                                                          //
//////////////////////////////////////////////////////////////////////////////
extern unsigned char bounce[];
extern unsigned char crack[];
extern unsigned char endlevel[];
extern unsigned char pickup[];
extern unsigned char gameover[];
extern unsigned char breakgl[];

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
extern int soundpriority;
extern void *soundptr;
extern long soundblocks;
extern int soundbank;
extern int soundoldbank;

//////////////////////////////////////////////////////////////////////////////
// SOUND_PLAYING                                                            //
//////////////////////////////////////////////////////////////////////////////
#define SOUND_PLAYING \
	soundblocks

//////////////////////////////////////////////////////////////////////////////
// SOUND_WAIT                                                               //
//////////////////////////////////////////////////////////////////////////////
#define SOUND_WAIT \
	while (soundblocks)

//////////////////////////////////////////////////////////////////////////////
// prototypes                                                               //
//////////////////////////////////////////////////////////////////////////////
void InitSound();
int PlaySound(int priority, void *data, int bank);
void FinishSound();

#endif // _SOUND_H
