//////////////////////////////////////////////////////////////////////////////
// SOUNDC.C                                                                 //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "sound.h"
#include "gameplay.h"

//////////////////////////////////////////////////////////////////////////////
// InitSound                                                                //
//////////////////////////////////////////////////////////////////////////////
void InitSound()
{
	NR52_REG = 0x84;		// enable sound 3
	NR30_REG = 0x00;		// sound 3 - output stop
	NR51_REG = 0x00;		// no sound output
	NR50_REG = 7<<4 | 7;	// SO1 & SO2 volume
	NR51_REG = 4<<4 | 4;	// sound 3 to SO1 & SO2
	NR31_REG = 0x80;		// sound 3 - sound length
	NR32_REG = 0x20;		// sound 3 - output level
	NR33_REG = 0x00;		// sound 3 - frequency LSB
	soundblocks = 0;
}

//////////////////////////////////////////////////////////////////////////////
// PlaySound                                                                //
//////////////////////////////////////////////////////////////////////////////
int PlaySound(int priority, void *data, int bank)
{
	if (soundblocks > 0) if (priority <= soundpriority) return 1;
	soundpriority = priority;
	soundptr = (long*)data+1;
	soundbank = bank;
	SWITCH_ROM_MBC1(soundbank);
	soundblocks = *(long*)data;
	SWITCH_ROM_MBC1(defaultbank);
	return 0;
}
