//////////////////////////////////////////////////////////////////////////////
// SPRITES.C                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include "sprites.h"
#include "gameplay.h"

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
Sprite sprites16x16[MAX_SPRITES_16x16];
//Sprite sprites8x16[MAX_SPRITES_8x16];

#define COOL \
		long x = s->x - scrollx; \
		long y = s->y - scrolly; \
		if ((x < -16) || (x > 200) || (y < -16) || (y > 200)) continue; \
		(*oam)[0] = y; \
		(*oam)[1] = x; \
		(*oam)[2] = s->firsttile; \
		(*oam++)[3] = s->prop; \
		(*oam)[0] = y; \
		(*oam)[1] = x+8; \
		(*oam)[2] = s->firsttile+2; \
		(*oam++)[3] = s->prop; \
		left-=2;

//////////////////////////////////////////////////////////////////////////////
// DrawSprites - Draw                                                       //
//////////////////////////////////////////////////////////////////////////////
void DrawSprites()
{
	int i, left=40;
	UBYTE (*oam)[4] = (void*)0xC000;
	Sprite *s;
	long bx, by;

	// draw 16x16 sprites
	s = sprites16x16;
	bx = s->x - scrollx; // ball x (ball is the first sprite)
	by = s->y - scrolly; // ball y

/*
	// multiplayer
	if ((s+1)->x > s->x-5)
	{
		s = sprites16x16+1;
		do {COOL;} while (0);
		s = sprites16x16+0;
		do {COOL;} while (0);
	}
	else
	{
		s = sprites16x16+0;
		do {COOL;} while (0);
		s = sprites16x16+1;
		do {COOL;} while (0);
	}	
	s = sprites16x16+0;*/
	
	for (i=0; (i<MAX_SPRITES_16x16) && (left!=0); i++, s++)
	{
		COOL;
				
		// ball is on top of another sprite?
		if ((i != 0) && (x > bx-6) && (x < bx+6) && (y > by-6) && (y < by+6))
		{
			CheckSprite(s->firsttile>>2, s);
		}
	}
	
	// draw 8x16 sprites
	/*s = sprites8x16;
	for (i=0; (i<MAX_SPRITES_8x16) && (left!=0); i++, s++)
	{
		long x = s->x - scrollx;
		long y = s->y - scrolly;
		if (!((x < -16) || (x > 200) || (y < -16) || (y > 200))) // visible
		{
			(*oam)[0] = y;
			(*oam)[1] = x;
			(*oam)[2] = s->firsttile;
			(*oam++)[3] = s->prop;
			left--;
		}
		if ((counter & 0x1F) == 0) if ((s->firsttile-=2) <= 16*4) s->x = 0;
	}*/

	// hide unused sprites
	while (left--) (*oam++)[0] = 0;
}

//////////////////////////////////////////////////////////////////////////////
// ClearSprites - Clear all sprites                                         //
//////////////////////////////////////////////////////////////////////////////
void ClearSprites()
{
	int i;
	for (i=0; i<MAX_SPRITES_16x16; i++)
	{
		sprites16x16[i].x = 0;
	}
/*	for (i=0; i<MAX_SPRITES_8x16; i++)
	{
		sprites8x16[i].x = 0;
	}*/
}

//////////////////////////////////////////////////////////////////////////////
// NewSprite16x16 - Prepare a new 16x16 sprite                              //
//////////////////////////////////////////////////////////////////////////////
Sprite *NewSprite16x16()
{
	int i;
	for (i=0; i<MAX_SPRITES_16x16; i++)
	{
		if (sprites16x16[i].x == 0) return &sprites16x16[i];
	}
	return 0;
}

//////////////////////////////////////////////////////////////////////////////
// NewSprite8x16 - Prepare a new 8x16 sprite                                //
//////////////////////////////////////////////////////////////////////////////
/*Sprite *NewSprite8x16()
{
	int i;
	for (i=0; i<MAX_SPRITES_8x16; i++)
	{
		if (sprites8x16[i].x == 0) return &sprites8x16[i];
	}
	return 0;
}*/

//////////////////////////////////////////////////////////////////////////////
// PlaceNewSprite16x16 - Place a new 16x16 sprite on the map                //
//////////////////////////////////////////////////////////////////////////////
void PlaceNewSprite16x16(int x, int y, int spritetile, int pal)
{
	Sprite *s = NewSprite16x16();
	s->x = (x*16L) + 8;
	s->y = (y*16L) + 16;
	s->firsttile = spritetile<<2;
	s->prop = 8+pal;
}

//////////////////////////////////////////////////////////////////////////////
// PlaceBallSprite16x16 - Place ball sprite                                 //
//////////////////////////////////////////////////////////////////////////////
void PlaceBallSprite16x16(int x, int y, int spritetile, int pal)
{
	PlaceNewSprite16x16(x,y, spritetile, pal);
	// init ball sprite
	ballx = (x*16L + 6)*16L;
	bally = (y*16L + 6)*16L;
	balltile = spritetile;
}
