//////////////////////////////////////////////////////////////////////////////
// SPRITES.H                                                                //
//////////////////////////////////////////////////////////////////////////////
#ifndef _SPRITES_H
#define _SPRITES_H

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>

//////////////////////////////////////////////////////////////////////////////
// defines                                                                  //
//////////////////////////////////////////////////////////////////////////////
#define MAX_SPRITES_16x16 20
//#define MAX_SPRITES_8x16 20

//////////////////////////////////////////////////////////////////////////////
// typedefs                                                                 //
//////////////////////////////////////////////////////////////////////////////
typedef struct
{
	long x,y; // x=0 if unused
	UBYTE firsttile;
	UBYTE prop;
} Sprite;

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
extern Sprite sprites16x16[MAX_SPRITES_16x16];
//extern Sprite sprites8x16[MAX_SPRITES_8x16];

//////////////////////////////////////////////////////////////////////////////
// KILL_SPRITE - Kill sprite by setting x to 0                              //
//////////////////////////////////////////////////////////////////////////////
#define KILL_SPRITE(s) \
{ \
	(s)->x = 0; \
}

//////////////////////////////////////////////////////////////////////////////
// prototypes                                                               //
//////////////////////////////////////////////////////////////////////////////
void DrawSprites();
void ClearSprites();
Sprite *NewSprite16x16();
//Sprite *NewSprite8x16();
void PlaceNewSprite16x16(int x, int y, int spritetile, int pal);
void PlaceBallSprite16x16(int x, int y, int spritetile, int pal);

#endif // _SPRITES_H
