//////////////////////////////////////////////////////////////////////////////
// BIN2O.CPP                                                                //
//////////////////////////////////////////////////////////////////////////////
#include <stdio.h>
#include <string.h>

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
	if (argc < 2) { printf("%s <input.bin> [banknr]\n", argv[0]); return 1; }

	FILE *fi = fopen(argv[1], "rb");
	if (!fi) { printf("Error opening input file!\n"); return 1; }

	char s[256]; strcpy(s, argv[1]);
	char *p = strrchr(s, '.'); if (p) *p = 0; // remove extension
	strcat(s, ".o"); // add .o extension
	FILE *fo = fopen(s, "wt");
	if (!fo) { printf("Error creating output file!\n"); return 1; }

	char *bank = 0;
	if (argc >= 3) bank = argv[2];

	char id[256];
	{
		char *p = strrchr(argv[1], '/'); // remove path
		if (!p) p = strrchr(argv[1], '\\'); // remove path
		if (!p) p = argv[1]-1;
		p++;
		strcpy(id, "_");
		strcat(id, p);
		p = strrchr(id, '.'); if (p) *p = 0; // remove extension
	}

	fseek(fi, 0, SEEK_END);
	long size = ftell(fi);
	fseek(fi, 0, SEEK_SET);

	fprintf(fo, "XL\n");
	if (!bank)
	{
		fprintf(fo, "H 3 areas 1 global symbols\n");
		fprintf(fo, "A _CODE size 0 flags 0\n");
		fprintf(fo, "A _BSS size 0 flags 0\n");
		fprintf(fo, "A _DATA size %lX flags 0\n", size);
		fprintf(fo, "S %s Def0000\n", id);
		//fprintf(fo, "A _LIT size 0 flags 0\n");
	}
	else
	{
		fprintf(fo, "H 3 areas 1 global symbols\n");
		fprintf(fo, "A _CODE size 0 flags 0\n");
		fprintf(fo, "A _CODE_%s size 0 flags 0\n", bank);
		fprintf(fo, "A _DATA_%s size %lX flags 0\n", bank, size);
		fprintf(fo, "S %s Def0000\n", id);
	}

	char buf[256];
	long addr = 0;
	while (!feof(fi)) {
		int read = fread(&buf, 1, 14, fi);
		fprintf(fo, "T %02lX %02lX", addr&0xFF, addr>>8);
		for (int n=0; n<read; n++) fprintf(fo, " %02X", buf[n]);
		fprintf(fo, "\nR 00 00 02 00\n");
		addr += read;
	}

	fclose(fi);
	fclose(fo);
	return 0;
}