//////////////////////////////////////////////////////////////////////////////
// FIXMAP.CPP                                                               //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <stdio.h>

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
char tilemap[64][64];
char attrmap[64][64];

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])
{
	if (argc < 2) { printf("%s <map.bin>\n", argv[0]); return 1; }

	// read file
	FILE *f = fopen(argv[1], "rb");
	if (!f) { printf("Error opening map file!\n"); return 1; }
	if (
		(fread(tilemap, 1, sizeof(tilemap), f) != sizeof(tilemap)) ||
		(fread(attrmap, 1, sizeof(attrmap), f) != sizeof(attrmap)) ||
		(fgetc(f) != EOF)
	) { printf("Map file size error!\n"); return 1; }
	fclose(f);

	// process map
	for (int y=0; y<64; y++)
	{
		for (int x=0; x<64; x++)
		{
			// walls must have priority bit set
			if ((tilemap[y][x] >= 48) || (tilemap[y][x] == 8))
			{
				attrmap[y][x] |= 0x80; // set priority bit
			}
		}
	}

	// write file
	f = fopen(argv[1], "wb");
	if (!f) { printf("Error writing map file!\n"); return 1; }
	fwrite(tilemap, sizeof(tilemap), 1, f);
	fwrite(attrmap, sizeof(attrmap), 1, f);
	fclose(f);

	return 0;
}